/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.services.HangingProtocol.testcases.customizedscp;


import cdac.medinfo.sdk.dcm30_04.baselibs.SQ;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataElement;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataSet;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IItem;
import cdac.medinfo.sdk.dcm30_04.enums.EnumLoggingLevel;
import cdac.medinfo.sdk.dcm30_04.enums.EnumPDUType;
import cdac.medinfo.sdk.dcm30_04.services.association.AReleaseRQorRP;
import cdac.medinfo.sdk.dcm30_04.services.association.AssociateRQ;
import cdac.medinfo.sdk.dcm30_04.services.association.AssociationNegotiator;
import cdac.medinfo.sdk.dcm30_04.services.association.DefaultAssociation;
import cdac.medinfo.sdk.dcm30_04.services.association.IDIMSEAssociation;
import cdac.medinfo.sdk.dcm30_04.services.cfind.scp.CFindSCP;
import cdac.medinfo.sdk.dcm30_04.services.dicomnetcommons.EnumDataSource;
import cdac.medinfo.sdk.dcm30_04.services.dicomnetcommons.EnumServiceType;
import cdac.medinfo.sdk.dcm30_04.services.dimsecommons.DIMSEResponse;
import cdac.medinfo.sdk.dcm30_04.services.hangingprotocol.sourceimpl.HangingProtocolDataSourceImpl;
import cdac.medinfo.sdk.dcm30_04.services.scp.commons.ClientSession;
import cdac.medinfo.sdk.dcm30_04.services.scp.commons.ProcessHandler;
import cdac.medinfo.sdk.dcm30_04.services.scp.commons.SCPSession;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.ICollectionIterator;

/**
 * This is the customized implementation of the test code for Hanging Protocol Services.
 * This sample codes is to show how user can define its own implementation for handling connection, association and service request.
 * In this sample test code all the required methods of IProcessHandler are implemented (onConnect(), onAssociateReceive() and onServiceRequest()) 
 * and their definition is provided here. User can define these methods according to his need.
 * This test code uses C-FIND SCP to process the Hanging Protocol request. Once the Data Source Implementation for 
 * Hanging Protocol is set on C-FIND SCP it is capable of handling C-FIND request.
 * To create DB for Hanging Protocol  refer SQL Script HangingProtocolDB.sql provided in install.
 */

public class HangingProtocol_CFind_SCP_Cust_ProcHandler {

	public static void main(String[] args)
	{
		try
		{		
			DicomConfig objDicomConfig = DicomConfig.createInstance();

			//enable logging,specify the path of the directory where log files are created.
			//User can specify any directory in place of 'c:\DCM_Logs'.
			//If no directory is defined by user to create logs then it is created in User Temp DIR.
			objDicomConfig.enableLogging(EnumLoggingLevel.INFO, "c:/DCM_Logs");


			//Creates TestCFind_SCP.
			TestCFindHangingProtocol_SCP objTestCFindHangingProtocol_SCP = new TestCFindHangingProtocol_SCP();

			//Create SCP session.
			SCPSession session = new SCPSession();
			String dataBasePath =  "c:/DataBase/HangingProtocolServerDB";
			String ConnectionString = "jdbc:derby://localhost:5050/" + dataBasePath;
			String driverString = "org.apache.derby.jdbc.ClientDriver";


			//Instantiating DataSource for HangingProtocolDataSourceImpl
			HangingProtocolDataSourceImpl objHangingProtocolDataSourceImpl = new HangingProtocolDataSourceImpl(ConnectionString,driverString);


			/*
			 * addDataSource on Process Handler. Here CFindSCPHandler is acting as the Process handler 
			 * for the test code. Hence adding Data Source to Process Handler.
			 */
			objTestCFindHangingProtocol_SCP.addDataSource(EnumDataSource.HANGING_PROTOCOL, objHangingProtocolDataSourceImpl);

			/*
			 * Initializes the supporting service types and sets it on SCP Session
			 * EnumService Type configures SCP Session to load corresponding association context and start
			 * corresponding DIMSE Services.
			 */
			EnumServiceType[] arrenumServiceType = new EnumServiceType[1];
			arrenumServiceType[0] = EnumServiceType.CFIND_HANGINGPROTOCOL;
			session.selectServices(arrenumServiceType);

			//Set objTestCStoreSRS_SCP as ProcessHandler.
			session.setIProcessHandler(objTestCFindHangingProtocol_SCP);

			/*
			 * Setting time out as 5000 milli second. It will wait 5000 milli seconds for read and write operation.
			 * If in the time specified (5000 ms) read or write operation is not performed then 
			 * session is time out.
			 */ 
			//session.setTimeOut(5000);

			//Start the Session
			session.start("SDK",9000);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
}
/**
 * Note ProcessHandler is the class which implements interface IProcessHandler or extends ProcessHandler.
 * This class is implemented to test the Hanging Protocol SCP.
 * In order to run the following class , please refer to this link($Link) to create the environment.
 * To implement an SCP of a particular we need to do the following things :
 * To create SCP user should either has to implement class IProcessHandler (which is an interface ) or extends Process handler.
 * If test code implements process handler then user has to provide implementation of the methods declared in the interface.
 * Otherwise he can extend the process handler which contains the default implementation for processing of association and service request.
 * Create the SCPSession object which maintains the session of the SCP. 
 * Set the services for which SCP is started and Process handler(reference of test code) in SCPSession.
 * Its "start" method starts the SCP server.
 * When an SCU connects to the SCP then the connection is accepted and client session is created for that SCU.
 * When SCU connects to the SCP the call back on onConnect of ProcessHandler is made. Now user can get the connection parameters
 * from client session and can decide whether to accept the connection or not. To accept the connection user has to
 * pass true to acceptConnection function in ClientSession class.
 * After the connection is established the next request expected to arrive at SCP is Association request.
 * When Association request arrives, callback is made to onAssociateReceive method of ProcessHandler.
 * User now can negotiate Association request with the default association and creates AssociateAC or Reject.
 * The library provides AssociationNegotiator Class to negotiate and create appropriate response.
 * When C-Store request arrives the call back is made to onServiceRequest method of ProcessHandler.
 * The user can get the C-Store Request from current ClientSession object passed in onServiceRequest method, processes it
 * and creates C-Find-RSP. SDK provides processRequest method in CFIND_SCP to process the request and generates response.
 * The Hanging Protocol SCP can handle multiple request simultaneously.
 * After this, when A-Release-RQ arrives , Create Release response and send it to the SCU.
 * Whenever the SCU goes down its client session is also closed or SCP can close the client session 
 * by calling close method of client session.
 */

class TestCFindHangingProtocol_SCP extends ProcessHandler
{
	/**
	 * This method notifies when a new client connection is requested. A decision is to be made whether to
	 * accept or reject the connection.  
	 * @param objClientSession  object of client session.
	 */
	public void onConnect(ClientSession objClientSession)
	{
		objClientSession.acceptConnection(true);
	}

	/**
	 * This method notifies when Association Request, Associate Release Request or Abort is received from one of the 
	 * SCUs. 
	 * If Association Request is received,
	 * 		Create Association Negotiator which negotiates the request with the existing default association and
	 * 		creates an AgreedAssociation which contains the negotiated association values. AssociationNegotiator
	 * 		returns the Association Response as AssociateAC when request is accepted or returns AssociateRJ is 
	 * 		none of the values in Association Request are acceptable.
	 * 	If Associate Release Request is received,
	 * 		Create a Associate Release Response and send the response to the SCU using the respective ClientSession.
	 *  If Abort is received,
	 *  	An Abort response must be generated and sent using ClientSession
	 *    
	 * @param objClientSession instance of Client Session.
	 */
	public void onAssociateReceive(ClientSession objClientSession) 
	{
		//Get Association RQ
		IDIMSEAssociation objIDIMSEAssociation = objClientSession.getDIMSEAssociation();
		EnumPDUType enumPDUType = objIDIMSEAssociation.getPDUType();
		IDIMSEAssociation objAssociationRSP = null;

		//For Association Request negotiate with Default Association and generate Response
		switch(enumPDUType)
		{
		case ASSOCIATE_RQ :
		{
			System.out.println("Association Request Received");
			AssociateRQ objAssociateRQ = (AssociateRQ)objIDIMSEAssociation;

			//get the default association from Client Session.
			DefaultAssociation objDefaultAssociation = objClientSession.getDefaultAssociation();

			//Negotiate and get Response
			AssociationNegotiator objAssNegotiator = new AssociationNegotiator();
			objAssociationRSP = objAssNegotiator.negotiate(objDefaultAssociation, objAssociateRQ);

			//set agreed association in client Session.
			objClientSession.setAgreedAssociation(objAssNegotiator.getAgreedAssociation());

			//Send Response
			objClientSession.sendAssociationMessage(objAssociationRSP);
			break;
		}
		case RELEASE_RQ :
		{
			System.out.println("Release Request Received");

			//Create Release Response.
			objAssociationRSP = new AReleaseRQorRP(EnumPDUType.RELEASE_RP);

			//Send Release Response.
			objClientSession.sendAssociationMessage(objAssociationRSP);
			System.out.println("Release Response sent");

			//Close Client Session
			objClientSession.close();
			break;
		}
		case ABORT :
		{
			System.out.println("Abort has arrived Stop Porcessing -- Association is no longer available");
			break;
		}
		}
	}

	/**
	 * This method notifies when a service related request is received.
	 * @param objClientSession  object of client session.
	 */
	public void onServiceRequest(ClientSession objClientSession)
	{
		/*
		 * Create CFindSCP get RQ from ClientSession call processRequest and pass CFindRequest on CFIND_SCP
		 * receive response from CFind_SCP sendResponse using ClientSession
		 */
		DIMSEResponse objDResponse = null;
		CFindSCP objCFindSCP = CFindSCP.createInstance(objClientSession); 
		try
		{
			System.out.println("HangingProtocolInfoQry  :: C-Find Request Received");
			/*
			 * Process CFind Request.
			 * Set DatasourceImpl for Hanging Protocol in C-Find SCP.
			 */
			objCFindSCP.setDataSourceList(getDataSourceList());
			
			System.out.println("*********************************************");
			display(objClientSession.getDicomMessage().getDataSet());
			System.out.println("*********************************************");
			
			objDResponse = objCFindSCP.processRequest(objClientSession.getDicomMessage());
	
			/*
			 * Send the service message through Client Session.
			 */
			if(objDResponse != null)
				objClientSession.sendServiceMessage(objDResponse);
		
			System.out.println("HangingProtocolInfoQry  :: C-Find Response Sent");
		}catch(Exception ioe)
		{
			ioe.printStackTrace();
		}
	}
	/*
	 * Displays the DataElements of Dataset
	 */
	private void display(IDataSet objIDataSet)
	{
		ICollectionIterator<IDataElement> objIDataSetIterator = objIDataSet.iterator();

		System.out.println("Tag     Value");
		while(objIDataSetIterator.hasNext())
		{
			IDataElement objDataElement = objIDataSetIterator.next();				

			if(!(objDataElement.getDicomValue() instanceof SQ))
			{

				System.out.println(objDataElement.getTag().getGroupNumber()+"    "+
						objDataElement.getTag().getElementNumber()+"    "+
						objDataElement.getDicomValue().toString());
			}
			else  
			{
				displaySequence((SQ)objDataElement.getDicomValue(),"> ");					
			}
		}
	}

	/*
	 * Displays the Dicom Data SQ.
	 */
	private void displaySequence(SQ objSQDataElement,String ss)
	{
		ICollectionIterator<IItem> objSQItemIterator = objSQDataElement.iterator();
		int i = 1;
		while(objSQItemIterator.hasNext())
		{
			System.out.println("ITEM :"+ i++ );
			IItem objItem = objSQItemIterator.next();
			ICollectionIterator<IDataElement> objDataElementIterator = objItem.iterator();
			while(objDataElementIterator.hasNext())
			{
				IDataElement objDataElement = objDataElementIterator.next();

				if(!(objDataElement.getDicomValue() instanceof SQ))
				{
					System.out.println(ss +objDataElement.getTag().getGroupNumber()+"    "+
							objDataElement.getTag().getElementNumber()+"    "+
							objDataElement.getDicomValue().toString());						 
				}
				else
				{
					displaySequence((SQ)objDataElement.getDicomValue(),ss+ss);
				}	 
			}
		}
	}
}
